HDU-2955-Robberies(01背包)

Robberies

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 23765 Accepted Submission(s): 8778

Problem Description
The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

For a few months now, Roy has been assessing the security of various banks and the amount of cash they hold. He wants to make a calculated risk, and grab as much money as possible.

His mother, Ola, has decided upon a tolerable probability of getting caught. She feels that he is safe enough if the banks he robs together give a probability less than this.

Input
The first line of input gives T, the number of cases. For each scenario, the first line of input gives a floating point number P, the probability Roy needs to be below, and an integer N, the number of banks he has plans for. Then follow N lines, where line j gives an integer Mj and a floating point number Pj .
Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output
For each test case, output a line with the maximum number of millions he can expect to get while the probability of getting caught is less than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all probabilities are independent as the police have very low funds.

Sample Input
3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output
2
4
6

题意:有个人抢劫银行,T组数据,首先输入被抓风险不能超过的最大概率,然后又n家银行,接下来n行是每家银行可抢到的金额,然后跟着是在这家银行被抓的风险概率,最后输出在限定的风险概率下最大能抢到的总金额
在这个背包中,价值就是金额,背包容积就是风险大小。

#include<stdio.h>///活用dp
#include<string.h>
#include<algorithm>
using namespace std;///需要注意的是,数据给的是被抓的概率,因此是要相乘(不是相加!!)才能得到同时抢几家银行被抓的概率,但这样,银行越多被抓的概率会越来越小,是不合理的
int main()///所以应该用1-被抓概率=存活概率,存活概率相乘才能得到更小的存活概率,这才是合理的,最终比较时,老妈给的也是最大风险概率,不能超过这个概率,反过来,1-风险=存活
{///也就是不能存活概率不能低于某个值
    int t,n,i,j,v[1080];///100个银行,每个银行最多100价值,也就是最大价值为10000,因此数组要存到10000
    double dp[10800],w[1080],wmin;///风险是小数,因此dp的应该是风险
    scanf("%d",&t);
    while(t--)
    {
        for(i=1; i<=10020; i++)///100*100的数组,因此最大的是10000的dp数组
        {
            dp[i]=0;///dp的是,在能抢到当前价值的情况下,存活的最大(max)概率值
        }
        scanf("%lf%d",&wmin,&n);///最大被抓概率 & 银行总数
        int sum=0;
        for(i=1; i<=n; i++)
        {
            scanf("%d%lf",&v[i],&w[i]);
            sum+=v[i];///求出最大价值以便作为dp的最大起点
            w[i]=1-w[i];///将输入的 被抓概率 转变为 存活概率
        }

        dp[0]=1;///起点,因为是乘法,所以起始是1不是0
        for(i=1; i<=n; i++)///一家一家银行选
        {
            for(j=sum; j>=v[i]; j--)
            {
                dp[j]=max(dp[j],(dp[j-v[i]]*w[i]));///对银行的风险进行取舍,选取存活概率最大的放入dp数组中
            }
//            for(int k=sum; k>=0; k--)
//            {
//                printf("%f\n",dp[k]);
//            }
//            printf("\n");
        }
        int ans=0;
        for(i=sum; i>=0; i--)///在dp后,从价值最大的往回找,直到找到某个价值的存活概率大于不能低于的的存活概率(因为获得的价值越多要抢的银行越多,存活的概率也是越少的,所以越上面的概率就越小)
        {
            if(1-wmin<=dp[i])///这里要将被抓概率转换为存活概率来比较
            {
                ans=i;///记录此时能获得的价值
                break;
            }
        }
        printf("%d\n",ans);
    }
    return 0;
}
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值